{% extends 'template/bootstrap_form_base.html.twig' %}

{% block title %}Demonstrator Application - {{ parent() }}{% endblock %}

{% block body %}
    <div class="container mt-6">
        <div class="box">
            {% if form.modulePreferences is not empty %}
                {{ form_start(form) }}
                <h1 class="h1 mt-4 mb-4">Demonstrator Application</h1>

                {{ form_row(form.fullName) }}
                {{ form_row(form.studentNumber) }}
                {{ form_row(form.universityEmailAddress) }}
                {{ form_row(form.visaStudent) }}
                {{ form_row(form.year) }}
                {{ form_row(form.postgraduateResearch, {
                    'row_attr': {'class': 'postgraduate-research-box'}
                }) }}
                {{ form_row(form.hasAppliedOfficially) }}

                <div class="modules-header">
                    <div class="form-group row">
                        <div class="col-sm-2">
                            Module ranking
                        </div>
                        <div class="col-sm-10">
                            Please rank how comfortable you would be demonstrating on each of
                            the modules below. Please note that these are only preferences.
                            Please do not try to game the system by submitting a dishonest
                            ranking, you would only harm yourself.
                        </div>
                    </div>
                    <div class="form-group row">
                        <div class="col-sm-2"></div>
                        <div class="col-sm-2">Not comfortable at all</div>
                        <div class="col-sm-6"></div>
                        <div class="col-sm-2 text-right">Delighted to</div>
                    </div>
                </div>
                {% for moduleField in form.modulePreferences %}
                    {{ form_row(moduleField.children.ranking, {
                        'label': moduleField.vars.data.name,
                        'row_attr': {'data-year': moduleField.vars.data.year, 'data-type': 'module-preference'}
                    }) }}
                {% endfor %}

                <div class="form-group row">
                    <div class="col-sm-2">
                        Modules taken
                    </div>
                    <div class="col-sm-10">
                        Please check all modules you are taking this year.
                        Not all modules you're taking this year will necessarily be on this list.
                        If you're a PhD student the list will be empty.
                    </div>
                </div>
                {% for moduleField in form.modulesTaken %}
                    {{ form_row(moduleField.children.taken, {
                        'label': moduleField.vars.data.name,
                        'row_attr': {'data-year': moduleField.vars.data.year, 'data-type': 'module-taken'}
                    }) }}
                {% endfor %}
                <div class="form-group row">
                    <div class="col-sm-2"></div>
                    <div class="col-sm-10">(End of list)</div>
                </div>

                <div class="form-group row timeslots-available">
                    <div class="col-sm-2">
                        Timeslots available
                    </div>
                    <div class="col-sm-10">
                        Please check all timeslots during which you are <span class="font-weight-bold">available</span>
                        to
                        demonstrate. For any slots you are unavailable you need to provide a valid reason.

                        <div class="d-lg-none">
                            <span class="font-weight-bold">Scroll to the right</span> to see all timeslots.
                        </div>

                        <div class="sdm-table-wrapper">
                            <table class="table">
                                {% set daysOfWeek = {0: 'Monday', 1: 'Tuesday', 2: 'Wednesday', 3: 'Thursday', 4: 'Friday'} %}
                                <tr>
                                    <th></th>
                                    {% for hourStart in 9..17 %}
                                        <th>{{ hourStart }} - {{ hourStart + 1 }}</th>
                                    {% endfor %}
                                </tr>
                                {% for i in 0..4 %}
                                    <tr>
                                        <th>{{ daysOfWeek[i] }}</th>
                                        {% for j in 0..8 %}
                                            <td>
                                                {{ form_widget(form.timeslotsAvailable[i * 9 + j].children.available) }}
                                            </td>
                                        {% endfor %}
                                    </tr>
                                {% endfor %}
                            </table>
                        </div>
                    </div>
                </div>

                {{ form_row(form.timeslotsUnavailableReasons, {
                    'row_attr': {'class': 'unavailable-reason-box'}
                }) }}

                {{ form_rest(form) }}

                <div class="mt-6"></div>

                {{ form_end(form) }}
            {% else %}
                Timetable entries must be <a href="{{ path('admin_app_module_import') }}">imported</a> first by an
                administrator.
            {% endif %}
        </div>
    </div>
{% endblock %}

{% block javascripts %}
    {{ parent() }}
    {{ encore_entry_script_tags('demonstrator-application') }}
{% endblock %}

{% block stylesheets %}
    {{ parent() }}
    {{ encore_entry_link_tags('demonstrator-application') }}
{% endblock %}
